/*****************************************************************************************
Company: ɶȻ޹˾ (Chengdu Hasion Electronics Co., Ltd.)
Tel: 028-86127089     0755-86066647
Fax: +86-28-86127039  
Website: http://www.hschip.com

Date: 2014-02-26
*****************************************************************************************/

#include<iom64v.h>
#include<macros.h>

#include"device.h"
#include"W5500.h"

/* ATMEGA64 IO ports Configuration*/
void IO_Config(void)
{
	DDRA=0xff;		/* PORTA is output */
	PORTA=0xff;

	DDRB=0x37;		/* Config PORTB3/PORTB6/PORTB7 are input, Others are input */
	PORTB=0xff;

	DDRC=0xff;		/* PORTC is output */
	PORTC=0xff;

	DDRD=0xff;		/* PORTD is output */
	PORTD=0xff;

	DDRE=0x76;		/* Config PORTE0/PORTE3/PORTE7 are input, others are output */
	PORTE=0xff;
	RESET_W5200

	DDRF=0xff;
	PORTF=0xff;

	DDRG=0xff;
	PORTG=0xff;

//	EICRA=0x00;
//	EICRB=0x80;		/* External INT7 falling edge interrupt */
//	EIMSK=0x80;		/* Enable INT7 */

	/* SPI Pins configuration */
	SPCR=0x50;		/* SPI interrupt disable, SPI enable, SPI Master*/
	SPSR=0x01;		/* fosc/2 */
}

/* Timer Configuration */
void Timer_Config(void)
{
	TIMSK=0x01;		/* Enable Timer0 overflow interrupt */
	TCCR0=0x05;		/* Timer0 clock is fosc/128 */
	TCNT0=170;		/* 1ms overflow */
}

//-----------------------------------------------------------------------------
//UART Initialization
//-----------------------------------------------------------------------------
/*void UART_Config(void)
{
	UCSR0A=0x00;
	UCSR0B=0xd8;		//Enable TX and RX, enable Tx and Rx inerrupt
	UCSR0C=0x86;		//1 start bit, 1 stop bit, 8 data bits, no parity

	UBRR0H=0;
	UBRR0L=fosc/16/BAUD_Rate-1;
}
*/

/* Delay d*1ms */
void Delay(unsigned int d)
{
	unsigned int i,j;

	i=timer0;
	do
	{
		if(i<timer0)
			j=timer0-i;
		else
			j=65536-i+timer0;
	}while(j<d);
}

/* Config W5500 */
void W5500_Config(void)
{
	unsigned char dat[6];
	
	Write_1_Byte(MR,RST);
	Delay(10);

	/* Set Gateway IP as 192.168.0.1 */
	dat[0]=192;
	dat[1]=168;
	dat[2]=0;
	dat[3]=1;
	Write_Bytes(GAR, dat, 4);

	/* Set Subnet Mask as 255.255.255.0 */
	dat[0]=255;
	dat[1]=255;
	dat[2]=255;
	dat[3]=0;
	Write_Bytes(SUBR, dat, 4);

	/* Set MAC Address as: 0x48,0x53,0x00,0x57,0x55,0x00 */
	dat[0]=0x48;
	dat[1]=0x53;
	dat[2]=0x00;
	dat[3]=0x57;
	dat[4]=0x55;
	dat[5]=0x00;
	Write_Bytes(SHAR, dat, 6);

	/* Set W5500 IP as 192.168.0.20 */
	dat[0]=192;
	dat[1]=168;
	dat[2]=0;
	dat[3]=20;
	Write_Bytes(SIPR, dat, 4);
	
	S0_Port=5000;			/* Socket0 port number */
}

/* Detect Gateway */
unsigned char Detect_Gateway(void)
{
	unsigned char dat[4];

	/* Set a different subnet destination IP */
	dat[0]=192+1;
	dat[1]=168+1;
	dat[2]=0+1;
	dat[3]=20+1;
	Write_SOCK_4_Byte(0,Sn_DIPR,dat);

	/* Set Socket n in TCP mode */
	Write_SOCK_1_Byte(0,Sn_MR,MR_TCP);
	/* Open Socket n */
	Write_SOCK_1_Byte(0,Sn_CR,OPEN);

	Delay(5);	/* Wait for a moment */
	if(Read_SOCK_1_Byte(0,Sn_SR)!=SOCK_INIT)
	{
		Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
		return false;
	}

	/* Set Socket n in Server mode */
	Write_SOCK_1_Byte(0,Sn_CR,CONNECT);
	
	do
	{
		if(Read_SOCK_1_Byte(0,Sn_IR)&IR_TIMEOUT) 	/* No Gateway Detected */
		{
			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
			return false;
		}
		else if(Read_SOCK_1_Byte(0,Sn_DHAR)!=0xff)	/* Detect Gateway */
		{
			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);		/* Close Socket 0 */
			break;
		}
	}while(1);
		
	return true;
}

/* Config Scoket */
void Socket0_Config(void)
{
	unsigned char dat[4];

	/* Set Socket 0 Port Number as 5000 */
	Write_SOCK_2_Byte(0,Sn_PORT,S0_Port);		
	S0_Port++;	 	/* Change Socket0 port number */

	/* Set Socket0 Destination IP as 192.168.0.40*/
	dat[0]=192;
	dat[1]=168;
	dat[2]=0;
	dat[3]=30;
	Write_SOCK_4_Byte(0,Sn_DIPR,dat);

	/* Set Socket0 Destination Port Number as 5000 */
	Write_SOCK_2_Byte(0,Sn_DPORTR,5000);		

	/* Set Maximum Segment Size as 1460 */
	Write_SOCK_2_Byte(0, Sn_MSSR, 1460);

	/* Set RX Buffer Size as 2K */
	Write_SOCK_1_Byte(0,Sn_RXBUF_SIZE, 0x02);
	/* Set TX Buffer Size as 2K */
	Write_SOCK_1_Byte(0,Sn_TXBUF_SIZE, 0x02);
}

/*Read interrup flag */
unsigned char Read_IR(SOCKET s)
{
	unsigned char i;

	i=Read_SOCK_1_Byte(s,Sn_IR);

	if(i!=0)
		Write_SOCK_1_Byte(s,Sn_IR,i);

	return i;
}

/* Process Received data */
void Loop_Back(void)
{
	unsigned int i;
	
	i=Read_SOCK_Data_Buffer(0, S_Buffer);      /* Read W5200 Data to Rx_Buffer */
	if(i==0)
		return;
	
	Write_SOCK_Data_Buffer(0, S_Buffer, i);
   	do
	{
		i=Read_SOCK_1_Byte(0,Sn_IR);
	}while(((i&IR_TIMEOUT)==0)&&((i&IR_SEND_OK)==0));
}

/***************************** Main Function ********************/
void main(void)
{
	unsigned char i;
	
	IO_Config();
	Timer_Config();

	SREG|=0x80;			/* Enable interrupt */
	Delay(50);
	SET_W5200
	
	/* Detect Ethernet Link */
	do
	{
		Delay(100);					/* wait 100ms */
		i=Read_1_Byte(PHYCFGR);
	}while((i&LINK)==0);

	W5500_Config();
	if(Detect_Gateway()==true)
		OUTPUT1_LOW

	while(1)
	{
		if((Read_1_Byte(PHYCFGR)&LINK)==0)	/* Detect Ethernet Link */
		{
			OUTPUT2_HIGH
			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);
			while((Read_1_Byte(PHYCFGR)&LINK)==0);		/* Wait Ethernet Link */
		}

		i=Read_IR(0);	/* Process IR */
		if(i&IR_TIMEOUT)
		{
			OUTPUT2_HIGH
			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);
		}		
		if(i&IR_CON)
			OUTPUT2_LOW
		if(i&IR_DISCON)
		{
			OUTPUT2_HIGH
			Write_SOCK_1_Byte(0,Sn_CR,CLOSE);
		}

		i=Read_SOCK_1_Byte(0,Sn_SR);
		if(i==0)
		{
			Socket0_Config();	
			while(Socket_Connect(0)==false)
				Delay(1000);
		}
		else if(i==SOCK_ESTABLISHED)
			Loop_Back();
	};
}

//#pragma interrupt_handler EXT_INT7:9
#pragma interrupt_handler TIMER0_OVR:17
//#pragma interrupt_handler USART0_Rx:19
//#pragma interrupt_handler USART0_Tx:21

/* External interrupt process */
//void EXT_INT7(void)
//{
//	W5200_Interrupt=1;
//}

/* Timer0 overflow interrupt */
void TIMER0_OVR(void)
{
	TCNT0=170;
	timer0++;
}

/* USART0 receive data process */
//void USART0_Rx(void)
//{
//}


/* USART0 transmit data process */
//void USART0_Tx(void)
//{
//}
